#ifndef _INCLUDES
#define _INCLUDES

#include <Eigen/Dense>
#include <math.h>
#define PI 3.141592653589793
#define CUTOFF 100
#define SAMPLE_RATE 5000

// Windows includes
#include <windows.h>
#include <iostream>
#include <fstream>
#include <string>
#include <conio.h>
//#include <chrono>
#include <ctime>
#include <stdio.h>
#include <time.h>

// Oculus includes
#include <glew.h>
#include <Extras/OVR_Math.h>
#include <OVR_CAPI_GL.h>
#include <OVR_CAPI.h>
#include <SDL.h>
#include <SDL_syswm.h>
#include "Shader.hpp"

// OpenHaptics includes
#include <HD/hd.h>
#include <HDU/hduVector.h>
#include <HDU/hduError.h>

// CHAI3D includes
#include <chai3d.h>

// Boost includes
#include <boost/thread.hpp>
#include <boost/thread/mutex.hpp>

// Virtualizer includes
#include <CVirtDeviceImpl.h>
#pragma comment(lib, "CybSDK.lib")

// OpenCV includes
#include <opencv2/core/core.hpp>
#include <opencv2/core/mat.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>

// V-REP includes
#include <v_repLib.h>
extern "C" {
#include <extApi.h>
#include <extApiPlatform.h>
}


#define M_PI 3.14159265358979323846
#define MAX_FPS 120
#define FULLSCREEN

#define TEST_NO

using namespace std;
using namespace OVR;
using namespace CybSDK;
using namespace cv;
using namespace chai3d;

extern simxInt clientID;
extern simxInt drone;
extern simxInt camera;


//! @brief converts a system timeval to seconds
//! @return converts a system timeval in seconds
inline double tv2sec(const SYSTEMTIME &tv_) {
	return (static_cast<double>(tv_.wSecond) + 1e-3*static_cast<double>(tv_.wMilliseconds));
}

double getTime();
void usleep(DWORD waitTime);


#endif _INCLUDES